#import <stdio.h>
#import <stdlib.h>
#import <stdint.h>
#import <math.h>
#import <complex.h>
#import <tmmintrin.h>
#import <objc/Object.h>

#import "BareClass.h"
#import "CalcObject.h"


#define re(z) (__real__ z)
#define im(z) (__imag__ z)

int main(int argc, const char *argv[])
{
   CalcFactor *a = [[CalcFactor alloc] init:NULL :factor :param],
              *b = [[CalcFactor alloc] init:NULL :factor :param],
              *c = [[CalcFactor alloc] init:NULL :factor :param];

   CalcObjectTreeNode leafLNode = (CalcObjectTreeNode){"a", a, NULL, NULL, 0},
                      leafRNode = (CalcObjectTreeNode){"b", b, NULL, NULL, 0},
                      rootNode  = (CalcObjectTreeNode){"c", c, &leafLNode, &leafRNode, 0};

   Calculator *calculator = [[Calculator alloc] initWithRootNode:&rootNode];

   [a setIntValue:11ll];
   [b setRealValue:3.14159L];
   [c setComplexValue:(long double complex){0.0L, 1.175201194L}];

   printf("%lld, %Lf, {%Lf, %LF}\n", [a evaluate].i, [b evaluate].r, re([c evaluate].z), im([c evaluate].z));

   [calculator release];

   return 0;
}
